// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from nao_sensor_msgs:msg/Touch.idl
// generated code does not contain a copyright notice
#include "nao_sensor_msgs/msg/detail/touch__rosidl_typesupport_fastrtps_cpp.hpp"
#include "nao_sensor_msgs/msg/detail/touch__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace nao_sensor_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_nao_sensor_msgs
cdr_serialize(
  const nao_sensor_msgs::msg::Touch & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: head_front
  cdr << (ros_message.head_front ? true : false);
  // Member: head_middle
  cdr << (ros_message.head_middle ? true : false);
  // Member: head_rear
  cdr << (ros_message.head_rear ? true : false);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_nao_sensor_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  nao_sensor_msgs::msg::Touch & ros_message)
{
  // Member: head_front
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.head_front = tmp ? true : false;
  }

  // Member: head_middle
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.head_middle = tmp ? true : false;
  }

  // Member: head_rear
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.head_rear = tmp ? true : false;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_nao_sensor_msgs
get_serialized_size(
  const nao_sensor_msgs::msg::Touch & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: head_front
  {
    size_t item_size = sizeof(ros_message.head_front);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: head_middle
  {
    size_t item_size = sizeof(ros_message.head_middle);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: head_rear
  {
    size_t item_size = sizeof(ros_message.head_rear);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_nao_sensor_msgs
max_serialized_size_Touch(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: head_front
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: head_middle
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: head_rear
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  return current_alignment - initial_alignment;
}

static bool _Touch__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const nao_sensor_msgs::msg::Touch *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _Touch__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<nao_sensor_msgs::msg::Touch *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _Touch__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const nao_sensor_msgs::msg::Touch *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _Touch__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_Touch(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _Touch__callbacks = {
  "nao_sensor_msgs::msg",
  "Touch",
  _Touch__cdr_serialize,
  _Touch__cdr_deserialize,
  _Touch__get_serialized_size,
  _Touch__max_serialized_size
};

static rosidl_message_type_support_t _Touch__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_Touch__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace nao_sensor_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_nao_sensor_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<nao_sensor_msgs::msg::Touch>()
{
  return &nao_sensor_msgs::msg::typesupport_fastrtps_cpp::_Touch__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, nao_sensor_msgs, msg, Touch)() {
  return &nao_sensor_msgs::msg::typesupport_fastrtps_cpp::_Touch__handle;
}

#ifdef __cplusplus
}
#endif
