// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from nao_sensor_msgs:msg/RobotConfig.idl
// generated code does not contain a copyright notice
#include "nao_sensor_msgs/msg/detail/robot_config__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "nao_sensor_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "nao_sensor_msgs/msg/detail/robot_config__struct.h"
#include "nao_sensor_msgs/msg/detail/robot_config__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "rosidl_runtime_c/string.h"  // body_id, body_version, head_id, head_version
#include "rosidl_runtime_c/string_functions.h"  // body_id, body_version, head_id, head_version

// forward declare type support functions


using _RobotConfig__ros_msg_type = nao_sensor_msgs__msg__RobotConfig;

static bool _RobotConfig__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _RobotConfig__ros_msg_type * ros_message = static_cast<const _RobotConfig__ros_msg_type *>(untyped_ros_message);
  // Field name: body_id
  {
    const rosidl_runtime_c__String * str = &ros_message->body_id;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: body_version
  {
    const rosidl_runtime_c__String * str = &ros_message->body_version;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: head_id
  {
    const rosidl_runtime_c__String * str = &ros_message->head_id;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: head_version
  {
    const rosidl_runtime_c__String * str = &ros_message->head_version;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  return true;
}

static bool _RobotConfig__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _RobotConfig__ros_msg_type * ros_message = static_cast<_RobotConfig__ros_msg_type *>(untyped_ros_message);
  // Field name: body_id
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->body_id.data) {
      rosidl_runtime_c__String__init(&ros_message->body_id);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->body_id,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'body_id'\n");
      return false;
    }
  }

  // Field name: body_version
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->body_version.data) {
      rosidl_runtime_c__String__init(&ros_message->body_version);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->body_version,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'body_version'\n");
      return false;
    }
  }

  // Field name: head_id
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->head_id.data) {
      rosidl_runtime_c__String__init(&ros_message->head_id);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->head_id,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'head_id'\n");
      return false;
    }
  }

  // Field name: head_version
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->head_version.data) {
      rosidl_runtime_c__String__init(&ros_message->head_version);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->head_version,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'head_version'\n");
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_nao_sensor_msgs
size_t get_serialized_size_nao_sensor_msgs__msg__RobotConfig(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _RobotConfig__ros_msg_type * ros_message = static_cast<const _RobotConfig__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name body_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->body_id.size + 1);
  // field.name body_version
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->body_version.size + 1);
  // field.name head_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->head_id.size + 1);
  // field.name head_version
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->head_version.size + 1);

  return current_alignment - initial_alignment;
}

static uint32_t _RobotConfig__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_nao_sensor_msgs__msg__RobotConfig(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_nao_sensor_msgs
size_t max_serialized_size_nao_sensor_msgs__msg__RobotConfig(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;

  // member: body_id
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: body_version
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: head_id
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: head_version
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _RobotConfig__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_nao_sensor_msgs__msg__RobotConfig(
    full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}


static message_type_support_callbacks_t __callbacks_RobotConfig = {
  "nao_sensor_msgs::msg",
  "RobotConfig",
  _RobotConfig__cdr_serialize,
  _RobotConfig__cdr_deserialize,
  _RobotConfig__get_serialized_size,
  _RobotConfig__max_serialized_size
};

static rosidl_message_type_support_t _RobotConfig__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_RobotConfig,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, nao_sensor_msgs, msg, RobotConfig)() {
  return &_RobotConfig__type_support;
}

#if defined(__cplusplus)
}
#endif
